<?php
/*
Name: Brazenly Custom Code
Author: Rick Beckman
Version: 1.0
Description: This box adds a custom text area into which any code — HTML, CSS, JS, and even PHP — may be entered, allowing it to be executed anywhere on the site to which this box can be dragged.
Class: brazenly_coded_box
*/


class brazenly_coded_box extends thesis_box {
	protected function translate() {
		$this->title = $this->name = __( 'Custom Code', 'brazenly_coded_box' );
	}

	protected function construct() {
		global $thesis;

		$thesis->wp->filter($this->_id);
	}

	protected function options() {
		global $thesis;

		return array(
			'code' => array(
				'type' => 'textarea',
				'rows' => 8,
				'code' => true,
				'label' => __( 'Code', 'brazenly_coded_box' ),
				'tooltip' => sprintf( __( 'This box allows you to insert %1$s, plain text, or %2$s. All text will be formatted just like a normal WordPress post, and all valid %1$s tags are allowed.<br /><br /><strong>Note:</strong> Scripts and %2$s which are improperly coded may break your site or prevent access to this screen. Check and double-check all code!', 'brazenly_coded_box' ), $thesis->api->base[ 'html' ], $thesis->api->base[ 'php' ] ) ),
			'id' => array(
				'type' => 'text',
				'width' => 'medium',
				'code' => true,
				'label' => $thesis->api->strings[ 'html_id' ],
				'tooltip' => $thesis->api->strings[ 'id_tooltip' ]
			),
			'class' => array(
				'type' => 'text',
				'width' => 'medium',
				'code' => true,
				'label' => $thesis->api->strings[ 'html_class' ],
				'tooltip' => $thesis->api->strings[ 'class_tooltip' ],
				'placeholder' => 'text_box'
			),
		);
	}

	public function html($depth) {
		global $thesis;

		$tab = str_repeat("\t", $depth);
		echo
			"$tab<div" . ($this->options[ 'id' ] ? ' id="' . trim( $thesis->api->esc( $this->options[ 'id' ] ) ) . '"' : '' ) . ' class="' . ( $this->options[ 'class' ] ? trim( $thesis->api->esc( $this->options[ 'class' ] ) ) : 'text_box' ) . "\">\n" .
			"$tab\t" . trim( apply_filters( $this->_id, eval( '?>' . stripslashes( $this->options[ 'code' ] ) . '<?php ' ) ) ) . "\n" .
			"$tab</div>\n";
	}
}